local mod = ...


--[[

    Quest to assign a Lord and Lady

]]




-- Default Balancing (event list) ---------------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND",
        "EVENT_AUTHORITY_START",
        "EVENT_AUTHORITY_EXCHEQUER",
        "EVENT_AUTHORITY_EXCHEQUER_ASSISTANT",
    }
})



-- Event: Authority Start ---------------------------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_AUTHORITY_START",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysBetweenOccurences = nil,
    DaysToFirst = 1,
    Delay = 10, 
    ConditionList = {
        {
            DataType = "GAME_CONDITION_BUILDING_BUILT",
            AssetBuilding = "MONUMENT_RUSTIC_LORD_MANOR"
        }
    },
	ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_AUTHORITY_LORD"
        },
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_AUTHORITY_LADY"
        },
    }
})



-- Quest: Lord ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_AUTHORITY_LORD",
    IsSilent = false,
	QuestFunction = {
        DataType = "QUEST_FUNCTION_CONTAINER",
        QuestContainerDescription = "QUESTION_CONTAINER_LORD_NAME",
        SubQuestList = {
            {
                DataType = "QUEST_FUNCTION_ASSIGN_BUILDING_FUNCTION", 
                AssetBuilding = "MONUMENT_RUSTIC_LORD_MANOR",
                AssetBuildingFunction = "BUILDING_FUNCTION_AUTHORITY_LORD"
            },
            {
                DataType = "QUEST_FUNCTION_ASSIGN_WORKER", 
                Job = "JOB_AUTHORITY_LORD",
            },
        }
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_RESOURCES",
            ResourceCollection = {
                {
                    Resource = "RESOURCE_AUTHORITY",
                    Quantity = 10
                }
            }
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil
})



-- Quest: Lady ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_AUTHORITY_LADY",
    IsSilent = false,
	QuestFunction = {
        DataType = "QUEST_FUNCTION_CONTAINER",
        QuestContainerDescription = "QUESTION_CONTAINER_LADY_NAME",
        SubQuestList = {
            {
                DataType = "QUEST_FUNCTION_ASSIGN_BUILDING_FUNCTION", 
                AssetBuilding = "MONUMENT_RUSTIC_LORD_MANOR",
                AssetBuildingFunction = "BUILDING_FUNCTION_AUTHORITY_LADY"
            },
            {
                DataType = "QUEST_FUNCTION_ASSIGN_WORKER", 
                Job = "JOB_AUTHORITY_LADY",
            },
        }
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_RESOURCES",
            ResourceCollection = {
                {
                    Resource = "RESOURCE_AUTHORITY",
                    Quantity = 10
                }
            }
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil
})



-- Event: Exchequer ---------------------------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_AUTHORITY_EXCHEQUER",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysBetweenOccurences = nil,
    DaysToFirst = 1,
    Delay = 10, 
    ConditionList = {
        {
            DataType = "GAME_CONDITION_QUEST_COMPLETED",
            Quest = "QUEST_AUTHORITY_LORD"
        },
        {
            DataType = "GAME_CONDITION_QUEST_COMPLETED",
            Quest = "QUEST_AUTHORITY_LADY"
        }
    },
	ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_AUTHORITY_EXCHEQUER"
        }
    }
})



-- Quest: Exchequer ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_AUTHORITY_EXCHEQUER",
    IsSilent = false,
	QuestFunction = {
        DataType = "QUEST_FUNCTION_CONTAINER",
        QuestContainerDescription = "QUESTION_CONTAINER_EXCHEQUER_NAME",
        SubQuestList = {
            {
                DataType = "QUEST_FUNCTION_ASSIGN_BUILDING_FUNCTION", 
                AssetBuilding = "MONUMENT_RUSTIC_LORD_MANOR",
                AssetBuildingFunction = "BUILDING_FUNCTION_AUTHORITY_EXCHEQUER"
            },
            {
                DataType = "QUEST_FUNCTION_ASSIGN_WORKER", 
                Job = "JOB_AUTHORITY_EXCHEQUER",
            },
        }
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_IMMIGRATION_WAVE"
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil
})




-- Event: Exchequer Assistant ---------------------------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_AUTHORITY_EXCHEQUER_ASSISTANT",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysBetweenOccurences = nil,
    DaysToFirst = 1,
    Delay = 10, 
    ConditionList = {
        {
            DataType = "GAME_CONDITION_QUEST_COMPLETED",
            Quest = "QUEST_AUTHORITY_EXCHEQUER"
        }
    },
	ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_AUTHORITY_EXCHEQUER_ASSISTANT"
        }
    }
})



-- Quest: Exchequer Assistant ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_AUTHORITY_EXCHEQUER_ASSISTANT",
    IsSilent = false,
	QuestFunction = {
        DataType = "QUEST_FUNCTION_CONTAINER",
        QuestContainerDescription = "QUESTION_CONTAINER_EXCHEQUER_ASSISTANT_NAME",
        SubQuestList = {
            {
                DataType = "QUEST_FUNCTION_ASSIGN_BUILDING_FUNCTION", 
                AssetBuilding = "MONUMENT_RUSTIC_LORD_MANOR",
                AssetBuildingFunction = "BUILDING_FUNCTION_AUTHORITY_EXCHEQUER_ASSISTANT"
            },
            {
                DataType = "QUEST_FUNCTION_ASSIGN_WORKER", 
                Job = "JOB_AUTHORITY_EXCHEQUER_ASSISTANT",
            },
        }
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_RESOURCES",
            ResourceCollection = {
                {
                    Resource = "RESOURCE_AUTHORITY",
                    Quantity = 10
                }
            }
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil
})
