local mod = ...



-- Job: Clerk of the Treasury -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_TREASURY",
	JobName = "JOB_TREASURY_NAME",
	JobDescription = "JOB_TREASURY_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 50, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_FARMER_SEED_BAG", 
		-- 	WorkAttachName = "SeedBag_Anchor", 
		-- 	WalkAttachName = "SeedBag_Anchor"
		-- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREASURY"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREASURY"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREASURY"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TREASURY"
    }
})



-- Building Function: Treasury -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_FUNCTION_TREASURY",
    WorkerCapacity = 1,
    RelatedJob = {
        Job = "JOB_TREASURY",
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 0 },
	},
    ResourceListNeeded = {
		{ Resource = "GOLD_COINS", Quantity = 0 }
	},
    ResourceProduced = {
		{ Resource = "GOLD_COINS", Quantity = 0 }
	}
})
